% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cuml_utils.R
\name{has_libcuml}
\alias{has_libcuml}
\title{Determine whether {cuml} was linked to a valid version of the RAPIDS cuML
shared library.}
\usage{
has_libcuml()
}
\value{
A logical value indicating whether the current installation {cuml}
  was linked to a valid version of the RAPIDS cuML shared library.
}
\description{
Determine whether {cuml} was linked to a valid version of the RAPIDS cuML
shared library.
}
\examples{

library(cuml)

if (!has_libcuml()) {
  warning(
    "Please install the RAPIDS cuML shared library first, and then re-",
    "install {cuml}."
  )
}
}
